// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/google/uuid"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/item"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/itemmeta"
	"gitlab.com/pajaziti.bersen/agorus-ent/ent/predicate"
)

// ItemMetaUpdate is the builder for updating ItemMeta entities.
type ItemMetaUpdate struct {
	config
	hooks    []Hook
	mutation *ItemMetaMutation
}

// Where appends a list predicates to the ItemMetaUpdate builder.
func (imu *ItemMetaUpdate) Where(ps ...predicate.ItemMeta) *ItemMetaUpdate {
	imu.mutation.Where(ps...)
	return imu
}

// SetKey sets the "key" field.
func (imu *ItemMetaUpdate) SetKey(s string) *ItemMetaUpdate {
	imu.mutation.SetKey(s)
	return imu
}

// SetValue sets the "value" field.
func (imu *ItemMetaUpdate) SetValue(s string) *ItemMetaUpdate {
	imu.mutation.SetValue(s)
	return imu
}

// SetCreatedAt sets the "created_at" field.
func (imu *ItemMetaUpdate) SetCreatedAt(t time.Time) *ItemMetaUpdate {
	imu.mutation.SetCreatedAt(t)
	return imu
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (imu *ItemMetaUpdate) SetNillableCreatedAt(t *time.Time) *ItemMetaUpdate {
	if t != nil {
		imu.SetCreatedAt(*t)
	}
	return imu
}

// SetUpdatedAt sets the "updated_at" field.
func (imu *ItemMetaUpdate) SetUpdatedAt(t time.Time) *ItemMetaUpdate {
	imu.mutation.SetUpdatedAt(t)
	return imu
}

// SetItemID sets the "item_id" field.
func (imu *ItemMetaUpdate) SetItemID(u uuid.UUID) *ItemMetaUpdate {
	imu.mutation.SetItemID(u)
	return imu
}

// SetMetafilterID sets the "metafilter_id" field.
func (imu *ItemMetaUpdate) SetMetafilterID(u uuid.UUID) *ItemMetaUpdate {
	imu.mutation.SetMetafilterID(u)
	return imu
}

// SetItem sets the "item" edge to the Item entity.
func (imu *ItemMetaUpdate) SetItem(i *Item) *ItemMetaUpdate {
	return imu.SetItemID(i.ID)
}

// Mutation returns the ItemMetaMutation object of the builder.
func (imu *ItemMetaUpdate) Mutation() *ItemMetaMutation {
	return imu.mutation
}

// ClearItem clears the "item" edge to the Item entity.
func (imu *ItemMetaUpdate) ClearItem() *ItemMetaUpdate {
	imu.mutation.ClearItem()
	return imu
}

// Save executes the query and returns the number of nodes affected by the update operation.
func (imu *ItemMetaUpdate) Save(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	imu.defaults()
	if len(imu.hooks) == 0 {
		if err = imu.check(); err != nil {
			return 0, err
		}
		affected, err = imu.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*ItemMetaMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			if err = imu.check(); err != nil {
				return 0, err
			}
			imu.mutation = mutation
			affected, err = imu.sqlSave(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(imu.hooks) - 1; i >= 0; i-- {
			if imu.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = imu.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, imu.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// SaveX is like Save, but panics if an error occurs.
func (imu *ItemMetaUpdate) SaveX(ctx context.Context) int {
	affected, err := imu.Save(ctx)
	if err != nil {
		panic(err)
	}
	return affected
}

// Exec executes the query.
func (imu *ItemMetaUpdate) Exec(ctx context.Context) error {
	_, err := imu.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (imu *ItemMetaUpdate) ExecX(ctx context.Context) {
	if err := imu.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (imu *ItemMetaUpdate) defaults() {
	if _, ok := imu.mutation.UpdatedAt(); !ok {
		v := itemmeta.UpdateDefaultUpdatedAt()
		imu.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (imu *ItemMetaUpdate) check() error {
	if _, ok := imu.mutation.ItemID(); imu.mutation.ItemCleared() && !ok {
		return errors.New(`ent: clearing a required unique edge "ItemMeta.item"`)
	}
	return nil
}

func (imu *ItemMetaUpdate) sqlSave(ctx context.Context) (n int, err error) {
	_spec := &sqlgraph.UpdateSpec{
		Node: &sqlgraph.NodeSpec{
			Table:   itemmeta.Table,
			Columns: itemmeta.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeUUID,
				Column: itemmeta.FieldID,
			},
		},
	}
	if ps := imu.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := imu.mutation.Key(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: itemmeta.FieldKey,
		})
	}
	if value, ok := imu.mutation.Value(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: itemmeta.FieldValue,
		})
	}
	if value, ok := imu.mutation.CreatedAt(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeTime,
			Value:  value,
			Column: itemmeta.FieldCreatedAt,
		})
	}
	if value, ok := imu.mutation.UpdatedAt(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeTime,
			Value:  value,
			Column: itemmeta.FieldUpdatedAt,
		})
	}
	if value, ok := imu.mutation.MetafilterID(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeUUID,
			Value:  value,
			Column: itemmeta.FieldMetafilterID,
		})
	}
	if imu.mutation.ItemCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   itemmeta.ItemTable,
			Columns: []string{itemmeta.ItemColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: item.FieldID,
				},
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := imu.mutation.ItemIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   itemmeta.ItemTable,
			Columns: []string{itemmeta.ItemColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: item.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if n, err = sqlgraph.UpdateNodes(ctx, imu.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{itemmeta.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return 0, err
	}
	return n, nil
}

// ItemMetaUpdateOne is the builder for updating a single ItemMeta entity.
type ItemMetaUpdateOne struct {
	config
	fields   []string
	hooks    []Hook
	mutation *ItemMetaMutation
}

// SetKey sets the "key" field.
func (imuo *ItemMetaUpdateOne) SetKey(s string) *ItemMetaUpdateOne {
	imuo.mutation.SetKey(s)
	return imuo
}

// SetValue sets the "value" field.
func (imuo *ItemMetaUpdateOne) SetValue(s string) *ItemMetaUpdateOne {
	imuo.mutation.SetValue(s)
	return imuo
}

// SetCreatedAt sets the "created_at" field.
func (imuo *ItemMetaUpdateOne) SetCreatedAt(t time.Time) *ItemMetaUpdateOne {
	imuo.mutation.SetCreatedAt(t)
	return imuo
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (imuo *ItemMetaUpdateOne) SetNillableCreatedAt(t *time.Time) *ItemMetaUpdateOne {
	if t != nil {
		imuo.SetCreatedAt(*t)
	}
	return imuo
}

// SetUpdatedAt sets the "updated_at" field.
func (imuo *ItemMetaUpdateOne) SetUpdatedAt(t time.Time) *ItemMetaUpdateOne {
	imuo.mutation.SetUpdatedAt(t)
	return imuo
}

// SetItemID sets the "item_id" field.
func (imuo *ItemMetaUpdateOne) SetItemID(u uuid.UUID) *ItemMetaUpdateOne {
	imuo.mutation.SetItemID(u)
	return imuo
}

// SetMetafilterID sets the "metafilter_id" field.
func (imuo *ItemMetaUpdateOne) SetMetafilterID(u uuid.UUID) *ItemMetaUpdateOne {
	imuo.mutation.SetMetafilterID(u)
	return imuo
}

// SetItem sets the "item" edge to the Item entity.
func (imuo *ItemMetaUpdateOne) SetItem(i *Item) *ItemMetaUpdateOne {
	return imuo.SetItemID(i.ID)
}

// Mutation returns the ItemMetaMutation object of the builder.
func (imuo *ItemMetaUpdateOne) Mutation() *ItemMetaMutation {
	return imuo.mutation
}

// ClearItem clears the "item" edge to the Item entity.
func (imuo *ItemMetaUpdateOne) ClearItem() *ItemMetaUpdateOne {
	imuo.mutation.ClearItem()
	return imuo
}

// Select allows selecting one or more fields (columns) of the returned entity.
// The default is selecting all fields defined in the entity schema.
func (imuo *ItemMetaUpdateOne) Select(field string, fields ...string) *ItemMetaUpdateOne {
	imuo.fields = append([]string{field}, fields...)
	return imuo
}

// Save executes the query and returns the updated ItemMeta entity.
func (imuo *ItemMetaUpdateOne) Save(ctx context.Context) (*ItemMeta, error) {
	var (
		err  error
		node *ItemMeta
	)
	imuo.defaults()
	if len(imuo.hooks) == 0 {
		if err = imuo.check(); err != nil {
			return nil, err
		}
		node, err = imuo.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*ItemMetaMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			if err = imuo.check(); err != nil {
				return nil, err
			}
			imuo.mutation = mutation
			node, err = imuo.sqlSave(ctx)
			mutation.done = true
			return node, err
		})
		for i := len(imuo.hooks) - 1; i >= 0; i-- {
			if imuo.hooks[i] == nil {
				return nil, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = imuo.hooks[i](mut)
		}
		v, err := mut.Mutate(ctx, imuo.mutation)
		if err != nil {
			return nil, err
		}
		nv, ok := v.(*ItemMeta)
		if !ok {
			return nil, fmt.Errorf("unexpected node type %T returned from ItemMetaMutation", v)
		}
		node = nv
	}
	return node, err
}

// SaveX is like Save, but panics if an error occurs.
func (imuo *ItemMetaUpdateOne) SaveX(ctx context.Context) *ItemMeta {
	node, err := imuo.Save(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// Exec executes the query on the entity.
func (imuo *ItemMetaUpdateOne) Exec(ctx context.Context) error {
	_, err := imuo.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (imuo *ItemMetaUpdateOne) ExecX(ctx context.Context) {
	if err := imuo.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (imuo *ItemMetaUpdateOne) defaults() {
	if _, ok := imuo.mutation.UpdatedAt(); !ok {
		v := itemmeta.UpdateDefaultUpdatedAt()
		imuo.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (imuo *ItemMetaUpdateOne) check() error {
	if _, ok := imuo.mutation.ItemID(); imuo.mutation.ItemCleared() && !ok {
		return errors.New(`ent: clearing a required unique edge "ItemMeta.item"`)
	}
	return nil
}

func (imuo *ItemMetaUpdateOne) sqlSave(ctx context.Context) (_node *ItemMeta, err error) {
	_spec := &sqlgraph.UpdateSpec{
		Node: &sqlgraph.NodeSpec{
			Table:   itemmeta.Table,
			Columns: itemmeta.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeUUID,
				Column: itemmeta.FieldID,
			},
		},
	}
	id, ok := imuo.mutation.ID()
	if !ok {
		return nil, &ValidationError{Name: "id", err: errors.New(`ent: missing "ItemMeta.id" for update`)}
	}
	_spec.Node.ID.Value = id
	if fields := imuo.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, itemmeta.FieldID)
		for _, f := range fields {
			if !itemmeta.ValidColumn(f) {
				return nil, &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
			}
			if f != itemmeta.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, f)
			}
		}
	}
	if ps := imuo.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := imuo.mutation.Key(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: itemmeta.FieldKey,
		})
	}
	if value, ok := imuo.mutation.Value(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: itemmeta.FieldValue,
		})
	}
	if value, ok := imuo.mutation.CreatedAt(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeTime,
			Value:  value,
			Column: itemmeta.FieldCreatedAt,
		})
	}
	if value, ok := imuo.mutation.UpdatedAt(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeTime,
			Value:  value,
			Column: itemmeta.FieldUpdatedAt,
		})
	}
	if value, ok := imuo.mutation.MetafilterID(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeUUID,
			Value:  value,
			Column: itemmeta.FieldMetafilterID,
		})
	}
	if imuo.mutation.ItemCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   itemmeta.ItemTable,
			Columns: []string{itemmeta.ItemColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: item.FieldID,
				},
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := imuo.mutation.ItemIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   itemmeta.ItemTable,
			Columns: []string{itemmeta.ItemColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: &sqlgraph.FieldSpec{
					Type:   field.TypeUUID,
					Column: item.FieldID,
				},
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	_node = &ItemMeta{config: imuo.config}
	_spec.Assign = _node.assignValues
	_spec.ScanValues = _node.scanValues
	if err = sqlgraph.UpdateNode(ctx, imuo.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{itemmeta.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	return _node, nil
}
